Index: tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/chartsengine/events/ProgressionEventCallBack.java
===================================================================
--- tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/chartsengine/events/ProgressionEventCallBack.java	(revision 0)
+++ tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/chartsengine/events/ProgressionEventCallBack.java	(revision 137)
@@ -0,0 +1,611 @@
+package org.txm.progression.rcp.chartsengine.events;
+
+import java.awt.AWTEvent;
+import java.awt.Color;
+import java.awt.event.KeyEvent;
+import java.awt.event.MouseEvent;
+import java.util.ArrayList;
+import java.util.List;
+
+import org.eclipse.e4.ui.workbench.modeling.EModelService;
+import org.eclipse.jface.viewers.StructuredSelection;
+import org.eclipse.jface.viewers.TableViewer;
+import org.eclipse.osgi.util.NLS;
+import org.eclipse.ui.IWorkbenchPage;
+import org.eclipse.ui.IWorkbenchWindow;
+import org.eclipse.ui.PartInitException;
+import org.eclipse.ui.PlatformUI;
+import org.eclipse.ui.part.EditorPart;
+import org.jfree.chart.ChartMouseEvent;
+import org.jfree.chart.entity.ChartEntity;
+import org.txm.chartsengine.rcp.events.EventCallBack;
+import org.txm.chartsengine.rcp.events.ZoomAndPanCallBack;
+import org.txm.functions.concordances.comparators.LineComparator;
+import org.txm.objects.Edition;
+import org.txm.objects.Page;
+import org.txm.objects.Text;
+import org.txm.progression.core.chartsengine.base.ProgressionChartCreator;
+import org.txm.progression.core.chartsengine.base.Utils;
+import org.txm.progression.core.functions.Progression;
+import org.txm.rcp.synoptic.commands.OpenEdition;
+import org.txm.rcp.synoptic.editor.EditionPanel.RGBA;
+import org.txm.rcp.synoptic.editor.SynopticEditionEditor;
+import org.txm.rcpapplication.Messages;
+import org.txm.rcpapplication.editors.concordances.ConcordancesEditor;
+import org.txm.rcpapplication.editors.input.ConcordancesEditorInput;
+import org.txm.rcpapplication.utils.SWTEditorsUtils;
+import org.txm.searchengine.cqp.corpus.Corpus;
+import org.txm.searchengine.cqp.corpus.Property;
+import org.txm.searchengine.cqp.corpus.StructuralUnit;
+import org.txm.searchengine.cqp.corpus.query.Match;
+import org.txm.utils.logger.Log;
+
+/**
+ * Progression chart mixed mouse and key user entries call back.
+ * 
+ * @author sjacquot
+ *
+ */
+public class ProgressionEventCallBack extends EventCallBack {
+
+	/**
+	 * To keep track of the concordance lines and recomputing only if the selected item is out of this range.
+	 */
+	protected int lastConcordanceTopLine = -1;
+	protected int lastConcordanceBottomLine = -1;
+	
+	/**
+	 * To keep track of the concordance lines sort and recomputing only if the sorting order has changed.
+	 */
+	protected LineComparator lastSortingComparator = null;
+	
+	
+
+//FIXME: version with TXMBroser old system edition
+//	@Override
+//	public void processEvent(final AWTEvent event, final int eventArea, final Object o) {
+//		
+//		// Need to run this in the SWT UI thread because it's called from the AWT UI thread in TBX charts engine layer
+//		chartEditor.getComposite().getDisplay().asyncExec(new Runnable() {
+//			public void run() {
+//
+//				// Mouse event
+//				if(event instanceof MouseEvent)	{
+//				
+//					MouseEvent mouseEvent = (MouseEvent)event;
+//					
+//					//return if it's not the left mouse button
+//					if(mouseEvent.getButton() != MouseEvent.BUTTON1)	{
+//						return;
+//					}
+//					
+//					
+//					ChartMouseEvent chartEvent = (ChartMouseEvent) o;
+//					ChartEntity entity = chartEvent.getEntity();
+//					final ArrayList<Integer> selectedPointPositions = Utils.getChartCreator(chartEditor.getChartsEngine()).getSelectedPointPositions(chartEditor.getChart());
+//	
+//					if(event.getID() == MouseEvent.MOUSE_CLICKED && mouseEvent.getClickCount() == 2 && eventArea == EventCallBack.AREA_ITEM && !selectedPointPositions.isEmpty()) {
+//	
+//						// Linked edition (CTRL/CMD + double click)
+//						if((mouseEvent.getModifiers() & ZoomAndPanCallBack.keyboardZoomModifierKeyMask) != 0) {
+//							// Updates the linked editor
+//							updateLinkedEditionEditor((TXMBrowser) chartEditor.getLinkedEditor(TXMBrowser.class), selectedPointPositions);
+//						}
+//						// Linked concordance
+//						else	{
+//							// Updates the linked editor
+//							updateLinkedConcordanceEditor(chartEditor.getLinkedEditors(ConcordancesEditor.class), selectedPointPositions);
+//						}
+//					}
+//					else if(event.getID() == MouseEvent.MOUSE_CLICKED && mouseEvent.getClickCount() == 1 && eventArea == EventCallBack.AREA_ITEM) {
+//
+//						// Get the linked concordance editors and update the one linked to the progression curve if it exists
+//						ArrayList<EditorPart> linkedConcordancesEditors = chartEditor.getLinkedEditors(ConcordancesEditor.class);
+//						if(!linkedConcordancesEditors.isEmpty())	{
+//							updateLinkedConcordanceEditor(linkedConcordancesEditors, selectedPointPositions);
+//						}
+//						
+//						
+//						// Get the linked edition editor and update it if exists
+//						TXMBrowser linkedEditionEditor = (TXMBrowser)chartEditor.getLinkedEditor(TXMBrowser.class);
+//						if(linkedEditionEditor != null)	{
+//							updateLinkedEditionEditor(linkedEditionEditor, selectedPointPositions);
+//						}
+//						
+//					}
+//					else if(event.getID() == MouseEvent.MOUSE_CLICKED && mouseEvent.getClickCount() == 2 && eventArea == EventCallBack.AREA_EMPTY) {
+//						// FIXME: debug
+//						//System.err.println("ProgressionMouseClickedCallBack.processEvent(...).new Runnable() {...}.run(): double click in empty area");
+//					}
+//					else if(event.getID() == MouseEvent.MOUSE_CLICKED && mouseEvent.getClickCount() == 1 && eventArea == EventCallBack.AREA_EMPTY) {
+//						// FIXME: debug
+//						//System.err.println("ProgressionMouseClickedCallBack.processEvent(...).new Runnable() {...}.run(): single click in empty area");
+//					}
+//				}
+//				// Key event
+//				else if(event instanceof KeyEvent)	{
+//					KeyEvent keyEvent = (KeyEvent)event;
+//					
+//					// return if zoom and pan modifier
+//					if((keyEvent.getModifiers() & ZoomAndPanCallBack.keyboardZoomModifierKeyMask) != 0) {
+//						return;
+//					}
+//					
+//					// Arrow keys
+//					if(keyEvent.getKeyCode() == KeyEvent.VK_LEFT || keyEvent.getKeyCode() == KeyEvent.VK_RIGHT)	{
+//					
+//						final ArrayList<Integer> selectedPointPositions = Utils.getChartCreator(chartEditor.getChartsEngine()).getSelectedPointPositions(chartEditor.getChart());
+//	
+//						// Get the linked concordance editors and update the one linked to the progression curve if it exists
+//						ArrayList<EditorPart> linkedConcordancesEditors = chartEditor.getLinkedEditors(ConcordancesEditor.class);
+//						if(!linkedConcordancesEditors.isEmpty())	{
+//							updateLinkedConcordanceEditor(linkedConcordancesEditors, selectedPointPositions);
+//						}
+//						
+//						// Get the linked edition editor and update it if exists
+//						TXMBrowser linkedEditionEditor = (TXMBrowser)chartEditor.getLinkedEditor(TXMBrowser.class);
+//						if(linkedEditionEditor != null)	{
+//							updateLinkedEditionEditor(linkedEditionEditor, selectedPointPositions);
+//						}
+//					}
+//				}
+//			}
+//		});
+//
+//	}
+
+	//FIXME: version with new SynopticEditionEditor system edition
+	@Override
+	public void processEvent(final AWTEvent event, final int eventArea, final Object o) {
+		
+		// Need to run this in the SWT UI thread because it's called from the AWT UI thread in TBX charts engine layer
+		chartEditor.getComposite().getDisplay().asyncExec(new Runnable() {
+			public void run() {
+
+				// Mouse event
+				if(event instanceof MouseEvent)	{
+				
+					MouseEvent mouseEvent = (MouseEvent)event;
+					
+					//return if it's not the left mouse button
+					if(mouseEvent.getButton() != MouseEvent.BUTTON1)	{
+						return;
+					}
+					
+					
+					ChartMouseEvent chartEvent = (ChartMouseEvent) o;
+					ChartEntity entity = chartEvent.getEntity();
+					final ArrayList<Integer> selectedPointPositions = Utils.getChartCreator(chartEditor.getChartsEngine()).getSelectedPointPositions(chartEditor.getChart());
+	
+					if(event.getID() == MouseEvent.MOUSE_CLICKED && mouseEvent.getClickCount() == 2 && eventArea == EventCallBack.AREA_ITEM && !selectedPointPositions.isEmpty()) {
+	
+						// Linked edition (CTRL/CMD + double click)
+						if((mouseEvent.getModifiers() & ZoomAndPanCallBack.keyboardZoomModifierKeyMask) != 0) {
+							// Updates the linked editor
+							updateLinkedEditionEditor((SynopticEditionEditor) chartEditor.getLinkedEditor(SynopticEditionEditor.class), selectedPointPositions);
+						}
+						// Linked concordance
+						else	{
+							// Updates the linked editor
+							updateLinkedConcordanceEditor(chartEditor.getLinkedEditors(ConcordancesEditor.class), selectedPointPositions);
+						}
+					}
+					else if(event.getID() == MouseEvent.MOUSE_CLICKED && mouseEvent.getClickCount() == 1 && eventArea == EventCallBack.AREA_ITEM) {
+
+						// Get the linked concordance editors and update the one linked to the progression curve if it exists
+						ArrayList<EditorPart> linkedConcordancesEditors = chartEditor.getLinkedEditors(ConcordancesEditor.class);
+						if(!linkedConcordancesEditors.isEmpty())	{
+							updateLinkedConcordanceEditor(linkedConcordancesEditors, selectedPointPositions);
+						}
+						
+						
+						// Get the linked edition editor and update it if exists
+						SynopticEditionEditor linkedEditionEditor = (SynopticEditionEditor)chartEditor.getLinkedEditor(SynopticEditionEditor.class);
+						if(linkedEditionEditor != null)	{
+							updateLinkedEditionEditor(linkedEditionEditor, selectedPointPositions);
+						}
+						
+					}
+					else if(event.getID() == MouseEvent.MOUSE_CLICKED && mouseEvent.getClickCount() == 2 && eventArea == EventCallBack.AREA_EMPTY) {
+						// FIXME: debug
+						//System.err.println("ProgressionMouseClickedCallBack.processEvent(...).new Runnable() {...}.run(): double click in empty area");
+					}
+					else if(event.getID() == MouseEvent.MOUSE_CLICKED && mouseEvent.getClickCount() == 1 && eventArea == EventCallBack.AREA_EMPTY) {
+						// FIXME: debug
+						//System.err.println("ProgressionMouseClickedCallBack.processEvent(...).new Runnable() {...}.run(): single click in empty area");
+					}
+				}
+				// Key event
+				else if(event instanceof KeyEvent)	{
+					KeyEvent keyEvent = (KeyEvent)event;
+					
+					// return if zoom and pan modifier
+					if((keyEvent.getModifiers() & ZoomAndPanCallBack.keyboardZoomModifierKeyMask) != 0) {
+						return;
+					}
+					
+					// Arrow keys
+					if(keyEvent.getKeyCode() == KeyEvent.VK_LEFT || keyEvent.getKeyCode() == KeyEvent.VK_RIGHT)	{
+					
+						final ArrayList<Integer> selectedPointPositions = Utils.getChartCreator(chartEditor.getChartsEngine()).getSelectedPointPositions(chartEditor.getChart());
+	
+						// Get the linked concordance editors and update the one linked to the progression curve if it exists
+						ArrayList<EditorPart> linkedConcordancesEditors = chartEditor.getLinkedEditors(ConcordancesEditor.class);
+						if(!linkedConcordancesEditors.isEmpty())	{
+							updateLinkedConcordanceEditor(linkedConcordancesEditors, selectedPointPositions);
+						}
+						
+						// Get the linked edition editor and update it if exists
+						SynopticEditionEditor linkedEditionEditor = (SynopticEditionEditor)chartEditor.getLinkedEditor(SynopticEditionEditor.class);
+						if(linkedEditionEditor != null)	{
+							updateLinkedEditionEditor(linkedEditionEditor, selectedPointPositions);
+						}
+					}
+				}
+			}
+		});
+
+	}
+	
+	
+	
+	/**
+	 * Updates the linked concordance editor.
+	 * If the editor doesn't exist it will be created.
+	 * @param editor
+	 */
+	public void updateLinkedConcordanceEditor(ArrayList<EditorPart> linkedEditors, ArrayList<Integer> selectedPointPositions)	{
+
+		// FIXME: Debug
+		//System.err.println("ProgressionEventCallBack.updateLinkedConcordanceEditor(): linked editors count: " + linkedEditors.size());
+		
+		IWorkbenchWindow window = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
+		IWorkbenchPage page = window.getActivePage();
+
+		// Get and format the progression query from the selected chart series
+		// FIXME: case 1, the query is the query of the selected chart series
+//		ArrayList<Integer> selectedSeries = chartEditor.getEditorInput().getSWTChartComponentsProvider().getChartsEngine().getProgressionChartSelectedSeries(chartEditor.getChart());
+//		String query = ((Progression) chartEditor.getResultData()).getQueries().get(selectedSeries.get(selectedSeries.size() - 1).intValue()).getQueryString();
+		
+		int lastSelectedSeries = Utils.getChartCreator(chartEditor.getChartsEngine()).getLastSelectedSeries(chartEditor.getChart());
+		String query = ((Progression) chartEditor.getResultData()).getQueries().get(lastSelectedSeries).getQueryString();
+
+		// Remove "[" and "]" only if it's a simple query as "[faire]" 
+		if(query.startsWith("[") && !query.contains("="))	{
+			int length = query.length();
+			if(query.endsWith("]"))	{
+				length--;
+			}
+			query = query.substring(1, length);
+		}
+
+		// FIXME: case 2, the query is the combination of all the queries of the progression
+//		String query = ((Progression) chartEditor.getResultData()).getQueriesString();
+		
+		
+		// gets the linked editor according to the query if it exists
+		ConcordancesEditor linkedEditor = null;
+		for(int i = 0; i < linkedEditors.size(); i++) {
+			if(query.equals(((ConcordancesEditor) linkedEditors.get(i)).getConcordance().getQuery().getQueryString()))	{
+				linkedEditor = ((ConcordancesEditor) linkedEditors.get(i));
+				break;
+			}
+		}
+		
+		
+		
+		ConcordancesEditorInput editorInput;
+		boolean newEditor = false;
+		// Create the linked editor input if needed
+		if(linkedEditor == null) {
+			editorInput = new ConcordancesEditorInput(((Progression) chartEditor.getResultData()).getCorpus(), null);
+			newEditor = true;
+		}
+		else	{
+			editorInput = (ConcordancesEditorInput) linkedEditor.getEditorInput();
+		}
+
+		try {
+			boolean wasOpenEditor = SWTEditorsUtils.isOpenEditor(editorInput);
+			
+			linkedEditor = (ConcordancesEditor) page.openEditor(editorInput, "org.txm.rcpapplication.editors.ConcordancesEditor", false); //$NON-NLS-1$
+			if(newEditor)	{
+				chartEditor.addLinkedEditor(linkedEditor);
+			}
+			
+			// Split the area and insert the new editor
+			if(!wasOpenEditor)	{
+				
+				int position = EModelService.BELOW;
+				EditorPart parentEditor = chartEditor;
+				
+				// Split vertically if there is already a concordance or an edition editor otherwise split horizontally
+				if(linkedEditors != null && !linkedEditors.isEmpty())	 {
+					position = EModelService.RIGHT_OF;
+					parentEditor = linkedEditors.get(linkedEditors.size() - 1);
+					
+					System.err.println("ProgressionEventCallBack.updateLinkedConcordanceEditor(): parent editor for splitting: " + parentEditor);
+				}
+				// Split and add linked editor
+				SWTEditorsUtils.addEditor(parentEditor, linkedEditor, position);
+			}
+			
+		}
+		catch (PartInitException e) {
+			System.err.println(NLS.bind(Messages.GetConcordances_4, e));
+		}
+
+		linkedEditor.setQuery(query);
+		// Compute the concordance if the query has changed or if the concordance has never been computed
+		if(linkedEditor.getConcordance() == null || newEditor)	{
+			linkedEditor.compute(false);
+			// initialize range change tracking variables
+			this.lastConcordanceTopLine = 0;
+			this.lastConcordanceBottomLine = linkedEditor.getLinePerPage();
+			this.lastSortingComparator = linkedEditor.getCurrentComparator();
+		}
+
+
+	
+		
+		final TableViewer tableViewer = linkedEditor.getLineTableViewer();
+		if(selectedPointPositions.size() > 0)	{
+
+			// Get the index of the last selected point in concordance according to the global token position and concordance sorting order
+			int lineIndex = linkedEditor.getConcordance().indexOf(selectedPointPositions.get(selectedPointPositions.size() - 1));
+			
+			int top = lineIndex - (lineIndex % linkedEditor.getLinePerPage());
+			int bottom = top + linkedEditor.getLinePerPage() - 1;
+			
+			
+			// Manage the lazy loading of new lines range in the concordance
+			boolean loadLines = false;
+			// not open editor (or new editor)
+			if(!SWTEditorsUtils.isOpenEditor(editorInput))	{
+				loadLines = true;
+			}
+			// page change
+			else if(this.lastConcordanceTopLine != top || this.lastConcordanceBottomLine != bottom)	{
+				loadLines = true;
+			}
+			// sort change
+			else if(this.lastSortingComparator != linkedEditor.getCurrentComparator())	{
+				loadLines = true;
+			}
+			
+			
+			// Loads new lines, fill the display area and select the table row
+			if(loadLines)	{
+				linkedEditor.fillDisplayArea(top, bottom);
+			}
+
+			// update range change tracking variables
+			this.lastConcordanceTopLine = top;
+			this.lastConcordanceBottomLine = bottom;
+			this.lastSortingComparator = linkedEditor.getCurrentComparator();
+
+			
+			
+			final int selectedPointInTableRange = lineIndex - top;						
+	
+			tableViewer.getControl().getDisplay().asyncExec(new Runnable() {
+				@Override
+				public void run() {
+					tableViewer.getTable().deselectAll();
+					
+					Object line = tableViewer.getElementAt(selectedPointInTableRange);
+					if(line != null)	{
+						tableViewer.setSelection(new StructuredSelection(line), true);
+						// FIXME: commented because the set top index makes the read of the table difficult
+						//tableViewer.getTable().setTopIndex(selectedPointInTableRange);
+					}
+					else	{
+						Log.info("Selected progression point doesn't exist in the linked Concordance.");
+					}
+				}
+			});
+		}
+		else	{
+			tableViewer.getTable().deselectAll();
+		}
+		
+		// give back the focus to chart editor
+		chartEditor.setFocus();
+	}
+
+	//FIXME: version with new SynopticEditionEditor system edition
+	/**
+	 * Updates the linked edition editor.
+	 * If the editor doesn't exist it will be created.
+	 * @param editor
+	 */
+	public void updateLinkedEditionEditor(SynopticEditionEditor linkedEditor, ArrayList<Integer> selectedPointPositions)	{
+		
+		
+		
+		
+		try {
+		
+			ArrayList<Color> seriesColors = chartEditor.getChartsEngine().getChartCreator(Progression.class).getSeriesShapesColors(chartEditor.getChart());
+			RGBA selectedWordColor = new RGBA(255, 10, 10);
+
+			//FIXME: old color
+			//RGBA lightred = new RGBA(249,208,208);
+			
+			// Unhighlight all tokens
+			if(linkedEditor != null)	{
+				linkedEditor.removeHighlightWords();
+			}
+			
+			Corpus corpus = ((Progression) chartEditor.getResultData()).getCorpus();
+			StructuralUnit textS = corpus.getStructuralUnit("text"); //$NON-NLS-1$
+			Property textP = textS.getProperty("id"); //$NON-NLS-1$
+			Match selectedWordMatch = new Match(selectedPointPositions.get(selectedPointPositions.size() - 1), selectedPointPositions.get(selectedPointPositions.size() - 1));
+			String textId = selectedWordMatch.getValueForProperty(textP);
+
+			Text text = corpus.getText(textId);
+			if(text == null) {
+				Log.severe("Text " + textId + " is missing.");
+				return;
+			}
+
+			Edition edition = text.getEdition(corpus.getMainCorpus().getDefaultEdition());
+
+			if(edition == null) {
+				Log.severe("Default edition is missing.");
+				return;
+			}
+
+			// Get the current selected word to highlight more
+			List<String> selectedWordIds = selectedWordMatch.getValuesForProperty(corpus.getProperty("id")); //$NON-NLS-1$;
+
+			// Get all words to highlight from the progression chart data set
+			ArrayList<ArrayList<Integer>> allPointPositionsBySeries = ((ProgressionChartCreator)chartEditor.getEditorInput().getChartsEngine().getChartCreator(Progression.class)).getAllPointPositionsBySeries(chartEditor.getChart());
+			
+			ArrayList<ArrayList<String>> allWordIds = new ArrayList<ArrayList<String>>(allPointPositionsBySeries.size());
+			for(int i = 0; i < allPointPositionsBySeries.size(); i++) {
+				ArrayList<Integer> positions = allPointPositionsBySeries.get(i);
+				ArrayList<String> wordsIds = new ArrayList<String>(); 
+				for(int j = 0; j < positions.size(); j++) {
+					Match match = new Match(positions.get(j), positions.get(j));					
+					if(match.getValueForProperty(textP).equals(textId)) {
+						wordsIds.add(match.getValueForProperty(corpus.getProperty("id"))); //$NON-NLS-1$;
+					}
+				}
+				allWordIds.add(wordsIds);
+			}
+
+			Page openPage = edition.getPageForWordId(selectedWordIds.get(0));
+
+			if(openPage != null) {
+
+				// Create the linked editor if needed
+				if(linkedEditor == null || linkedEditor.isDisposed()) {
+					linkedEditor = OpenEdition.openEdition(corpus, OpenEdition.getDefaultEditions(corpus));
+					chartEditor.addLinkedEditor(linkedEditor);
+					
+					
+					int position = EModelService.BELOW;;
+					EditorPart parentEditor = chartEditor;
+					// Split vertically if there is already a concordance editor otherwise split horizontally
+					ConcordancesEditor linkedConcordanceEditor = (ConcordancesEditor)chartEditor.getLinkedEditor(ConcordancesEditor.class);
+					if(linkedConcordanceEditor != null)	{
+						position = EModelService.RIGHT_OF;
+						parentEditor = linkedConcordanceEditor;
+					}
+					
+					// Split and add linked editor
+					SWTEditorsUtils.addEditor(parentEditor, linkedEditor, position);
+				}
+
+				linkedEditor.setText(text, true);
+				linkedEditor.goToPage(openPage.getName());
+				
+				// Highlight tokens by series
+				for(int i = 0; i < allWordIds.size(); i++) {
+					linkedEditor.addHighlightWordsById(new RGBA(seriesColors.get(i).getRed(), seriesColors.get(i).getGreen(), seriesColors.get(i).getBlue()), allWordIds.get(i));
+				}
+				// Highlight selected curve token
+				linkedEditor.addHighlightWordsById(selectedWordColor, selectedWordIds);
+				linkedEditor.setFocusedWordID(selectedWordIds.get(0)); // to scroll to the selected word
+				
+				IWorkbenchPage attachedPage = linkedEditor.getEditorSite().getPage();
+				attachedPage.activate(linkedEditor);
+			}
+		}
+		catch(Exception e) {
+			Log.printStackTrace(e);
+		}
+	}
+
+	//FIXME: version with TXMBroser old system edition
+//	/**
+//	 * Updates the linked edition editor.
+//	 * If the editor doesn't exist it will be created.
+//	 * @param editor
+//	 */
+//	public void updateLinkedEditionEditor(TXMBrowser linkedEditor, ArrayList<Integer> selectedPointPositions)	{
+//		
+//		try {
+//			
+//			// Unhighlight all tokens if no selected points
+//			if(selectedPointPositions.size() < 1)	{
+//				linkedEditor.setWordsIds(new ArrayList<String>(), new ArrayList<String>());
+//				linkedEditor.showPage(linkedEditor.getCurrentPage());
+//				return;
+//			}
+//			
+//			Corpus corpus = ((Progression2) chartEditor.getResultData()).getCorpus();
+//			StructuralUnit textS = corpus.getStructuralUnit("text"); //$NON-NLS-1$
+//			Property textP = textS.getProperty("id"); //$NON-NLS-1$
+//			Match selectedWordMatch = new Match(selectedPointPositions.get(selectedPointPositions.size() - 1), selectedPointPositions.get(selectedPointPositions.size() - 1));
+//			String textId = selectedWordMatch.getValueForProperty(textP);
+//
+//			Text text = corpus.getText(textId);
+//			if(text == null) {
+//				Log.severe("Text " + textId + " is missing.");
+//				return;
+//			}
+//
+//			Edition edition = text.getEdition(corpus.getMainCorpus().getDefaultEdition());
+//			if(edition == null) {
+//				Log.severe("Default edition is missing.");
+//				return;
+//			}
+//
+//			// Get the current selected word to highlight more
+//			List<String> selectedWordIds = selectedWordMatch.getValuesForProperty(corpus.getProperty("id")); //$NON-NLS-1$;
+//
+//			// Get all words to highlight from the progression chart data set
+//			ArrayList<Integer> allPointPositions = ((ProgressionChartCreator)chartEditor.getEditorInput().getChartsEngine().getChartCreator(Progression2.class)).getAllPointPositions(chartEditor.getChart());
+//			
+//			ArrayList<String> wordIds = new ArrayList<String>(allPointPositions.size());
+//			for(int i = 0; i < allPointPositions.size(); i++) {
+//				Match match = new Match(allPointPositions.get(i), allPointPositions.get(i));
+//				if(match.getValueForProperty(textP).equals(textId)) {
+//					wordIds.add(match.getValueForProperty(corpus.getProperty("id"))); //$NON-NLS-1$;
+//				}
+//			}
+//
+//			Page openPage = edition.getPageForWordId(selectedWordIds.get(0));
+//
+//			if(openPage != null) {
+//
+//				// Create the linked editor if needed
+//				if(linkedEditor == null || linkedEditor.isDisposed()) {
+//					linkedEditor = OpenBrowser.openEdition(openPage.getFile().getAbsolutePath(), openPage.getFile().getName());
+//					linkedEditor.setEdition(edition);
+//					chartEditor.addLinkedEditor(linkedEditor);
+//					
+//					
+//					int position = EModelService.BELOW;;
+//					EditorPart parentEditor = chartEditor;
+//					// Split vertically if there is already a concordance editor otherwise split horizontally
+//					ConcordancesEditor linkedConcordanceEditor = (ConcordancesEditor)chartEditor.getLinkedEditor(ConcordancesEditor.class);
+//					if(linkedConcordanceEditor != null)	{
+//						position = EModelService.RIGHT_OF;
+//						parentEditor = linkedConcordanceEditor;
+//					}
+//					
+//					// Split and add linked editor
+//					SWTEditorsUtils.addEditor(parentEditor, linkedEditor, position);
+//				}
+//
+//				linkedEditor.showPage(openPage);
+//				// Highlight tokens
+//				linkedEditor.setWordsIds(wordIds, selectedWordIds);
+//
+//				IWorkbenchPage attachedPage = linkedEditor.getEditorSite().getPage();
+//				attachedPage.activate(linkedEditor);
+//			}
+//		}
+//		catch(Exception e) {
+//			Log.printStackTrace(e);
+//		}
+//	}
+
+
+
+	
+	    
+}

